#include <LiquidCrystal.h>

const int PAUSE = 500;
const int RS = 8;
const int ENABLE = 9;
const int DB4 = 4;
const int DB5 = 5;
const int DB6 = 6;
const int DB7 = 7;

const int BTN_RIGHT = 0;
const int BTN_UP = 1;
const int BTN_DOWN = 2;
const int BTN_LEFT = 3;
const int BTN_SELECT = 4;
const int BTN_NONE = 5;

int lcdKey = 0;
int adcKey = 0;

LiquidCrystal lcd(RS, ENABLE, DB4, DB5, DB6, DB7);

void setup() {
  lcd.begin(16, 2);
  lcd.setCursor(0, 0);
  lcd.print("Push the buttons");
}

void loop() {
  lcdKey = readLcdButtons();
  lcd.setCursor(0, 1);
  lcd.print(String(lcdKey));
  delay(PAUSE);
  lcd.setCursor(0, 1);
  lcd.print(" ");
  delay(PAUSE / 10);
}

int readLcdButtons() {
  adcKey = analogRead(A0);
  if (adcKey > 1000)
    return BTN_NONE;
  if (adcKey < 50)
    return BTN_RIGHT;
  if (adcKey < 195)
    return BTN_UP;
  if (adcKey < 280)
    return BTN_DOWN;
  if (adcKey < 555)
    return BTN_LEFT;
  if (adcKey < 790)
    return BTN_SELECT;
  return BTN_NONE;
}
